#ifndef HTTP_TCPSERVER
#define HTTP_TCPSERVER

#include <stdio.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <stdlib.h>
#include <string>
#include <map>

namespace http{
    class TcpServer{
		public:
			TcpServer(std::string ip_address, int port);
			~TcpServer();
			void startListen();
			void registerRoute(std::string route, std::string document_path);
			void registerFile(std::string path, std::string name, std::string extension);
			void setContentPath(std::string new_path); //Supply content path without the last "/" symbol
			
		private:
			std::string contentPath;
			std::string m_ip_address;
			int m_port;
			int m_socket;
			int m_new_socket;
			long m_incomingMessage;
			struct sockaddr_in m_socketAddress;
			unsigned int m_socketAddress_len;
			std::string m_serverMessage;
			
			std::map<std::string,std::string> routeMap;
			
			int startServer();
			void closeServer();
			void acceptConnection(int &new_socket);
			std::string buildResponse(std::string filepath="index.html");
			std::string buildStatusResponse(const std::string& body, int statusCode = 200);
			void sendResponse();
			
    };
}

#endif